package td.mesClasses;

public class Morpion {

	public static void afficheGrille(int[][] t)
	{


		for (int i =0; i < t.length*2+1; i++)
			System.out.print('-');
		System.out.println();
		for (int y =0; y < t.length; y++)
		{
			for (int x =0; x <t.length; x++)
			{
				System.out.print('|');
				if (t[x][y]==1)
					System.out.print('O');
				else
					if (t[x][y]==2)
						System.out.print('X');
					else
						System.out.print(' ');
			}
			System.out.print('|');
			System.out.println();
			for (int i =0; i < t.length*2+1; i++)
				System.out.print('-');
			System.out.println();
		}
	}
	/*grille
	 * (0,0) (1,0) (2,0)
	 * (0,1) (1,1) (2,1)
	 * (0,2) (1,2) (2,2)
	 */
	public static void afficheJoueur(int joueur)
	{
		System.out.print("Le joueur courant est :");
		if (joueur==1)
			System.out.println('O');
		else
			System.out.println('X');
	}
	public static void debug(int[][] t)
	{
		for (int y=0; y < t.length; y++)
		{
			for(int x=0; x <t.length; x++)
			{
				System.out.print("t["+x+"]["+y+"]="+t[x][y]+" ");
			}
			System.out.println();
		}
	}

	public static boolean estCoupGagnant(int[][] t, int x, int y, int joueur)
	{
		boolean res = false;
		int xc, yc;

		int[][] delta = {{1,0},{1,-1},{0,-1},{-1,-1}};
		int dir=0;
		int dx, dy;
		int nb;
		while (!res && dir < delta.length)
		{


			nb = 1;

			dx=delta[dir][0];
			dy=delta[dir][1];
			xc  = x;
			yc = y;

			for (int i=0; i <2 ;i++)
			{
				dx = dx *-1;
				dy = dy *-1;
				xc  = x;
				yc = y;


				while (xc + dx < t.length && yc+ dy < t.length && 0 <= xc+dx && 0 <= yc+dy && t[xc+dx][yc+dy]==joueur)
				{
					nb++;
					xc = xc +dx;
					yc = yc +dy;
				}


			}
			res = (nb>=3);
			dir++;
		}
		return res;
	}

	public static boolean estJoubable(int[][] t, int x, int y)
	{
		boolean res = false;
		if (0<=x && x < t.length)
			if (0<=y && y<t[x].length)
			{
				res = (t[x][y]==0);
			}
		return res;
	}

	public static boolean estPlein(int[][] t)
	{
		boolean plein = true;
		int x=0;
		int y;
		while (x < t.length && plein)
		{
			y=0;
			while(y <t[x].length && plein)
			{
				plein =  (t[x][y]!=0);
				y++;
			}
			x++;
		}
		return plein;
	}
	public static void joue(int[][] t, int x, int y, int joueur)
	{
		t[x][y]=joueur;
	}
	public static int joueurSuivant(int joueur)
	{
		return (joueur % 2)+1;
	}
}