package td.mesClasses;

import java.util.Scanner;

public class TableauInt {
	public static void affiche(int [] t)
	{
		for(int i=0; i<t.length; i++)
		{
			System.out.println("t["+i+"]="+t[i]);
		}
	}
	public static int[] clone(int[] t)
	{
		int[] res = new int[t.length];
		for (int i =0; i < t.length; i++)
		{
			res[i]=t[i];
		}
		return res;
	}

	public static boolean egalite(int [] t1, int[] t2)
	{
		boolean res = true;
		if (t1.length == t2.length)
		{
			int i=0;
			while (res && i<t1.length)
			{
				if (t1[i]!=t2[i])
				{
					res = false;
				}	
				else
				{
					i++;
				}
			}	
		}
		else
		{
			res = false;
		}
		return res;
	}

	public static int max(int[] t)
	{
		return t[posPremierMax(t)];
	}

	public static int nbOccurence(int[] t, int val)
	{
		int res = 0;
		for (int i=0; i <t.length; i++)
		{
			if (t[i]==val)
			{
				res++;
			}
		}
		return res;
	}

	public static int posDernierMax(int[] t)
	{
		int pos = 0;
		for (int i=1; i<t.length; i++)
		{
			if (t[i]>=t[pos])
			{
				pos=i;
			}
		}
		return pos;
	}

	public static int[] posMax(int[] t)
	{
		int max = max(t);
		int nb = nbOccurence(t, max);
		int[] res = new int[nb];
		int cpt=0;
		for (int i=0; i<t.length; i++)
		{
			if (t[i]==max)
			{
				res[cpt]=i;
				cpt++;
			}
		}
		return res;
	}
	public static int posPremierMax(int[] t)
	{
		int pos = 0;
		for (int i=1; i<t.length; i++)
		{
			if (t[i]>t[pos])
			{
				pos=i;
			}
		}
		return pos;

	}

	public static int rechercheDichoT(int [] t, int elt)
	{
		int inf = 0;
		int sup = t.length -1;
		int m;
		int res = -1;
		while (res==-1 && inf <= sup)
		{
			m=(inf + sup)/2;
			if (t[m] > elt)
			{
				sup = m -1;
			}
			else
			{
				if (t[m] < elt)
				{
					inf = m  + 1;
				}
				else
				{
					res = m;
				}
			}
		}
		return res;
	}
	
	public static int rechercheS(int[] t, int elt)
	{
		int res = -1;
		int i=0;
		while(res==-1 && i<t.length)
		{
			if (t[i]==elt)
			{
				res = i;
			}
			else
			{
				i++;
			}
		}
		return res;
	}
	
	public static void remplissageA(int [] t, int max){
		for(int i=0; i<t.length; i++)
		{
			t[i]=(int) (Math.random() * max);
		}
	}
	
	public static void remplissageI(int [] t)
	{
		Scanner sc = new Scanner(System.in);
		for(int i=0; i<t.length; i++)
		{
			t[i]=sc.nextInt();
		}
	}
	
	public static void tri(int [] t)
	{
		int i,j,m;
		int l = t.length -1;
		for ( i=l; i>=0; i--)
			for (j=1; j<=i; j++)
				if (t[j-1] > t[j])
				{
					m = t[j-1];
					t[j-1] = t[j];
					t[j]=m;                      
				}
	}
}
